## ros-noetic-exotica-ddp-solver 6.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(exotica_ddp_solver)

find_package(catkin REQUIRED COMPONENTS
  exotica_core
  exotica_python
)

AddInitializer(
  abstract_ddp_solver
  analytic_ddp_solver
  control_limited_ddp_solver
  feasibility_driven_ddp_solver
  control_limited_feasibility_driven_ddp_solver
)
GenInitializers()

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS exotica_core
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

# Ignore Eigen::Tensor warnings
add_compile_options(-Wno-ignored-attributes)

set(SOURCES
  src/abstract_ddp_solver.cpp
  src/analytic_ddp_solver.cpp
  src/control_limited_ddp_solver.cpp
  src/feasibility_driven_ddp_solver.cpp
  src/control_limited_feasibility_driven_ddp_solver.cpp
)

add_library(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})
add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_initializers ${catkin_EXPORTED_TARGETS})

pybind_add_module(${PROJECT_NAME}_py MODULE src/ddp_solver_py.cpp)
target_link_libraries(${PROJECT_NAME}_py PRIVATE ${PROJECT_NAME})
add_dependencies(${PROJECT_NAME}_py ${PROJECT_NAME} ${PROJECT_NAME}_initializers ${catkin_EXPORTED_TARGETS})

install(TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})
install(DIRECTORY include/ DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})
install(FILES exotica_plugins.xml DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})
install(TARGETS ${PROJECT_NAME}_py LIBRARY DESTINATION ${CATKIN_GLOBAL_PYTHON_DESTINATION})

=== debian/changelog ===
ros-noetic-exotica-ddp-solver (6.2.0-1buster) buster; urgency=high

  * Performance improvements (#741 <https://github.com/ipab-slmc/exotica/issues/741>)
  * FDDP: Fix allocation
  * Use in-place StateDelta
  * Contributors: Wolfgang Merkt

 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Thu, 22 Jul 2021 23:00:00 -0000

ros-noetic-exotica-ddp-solver (6.1.1-1buster) buster; urgency=high



 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Sun, 04 Apr 2021 23:00:00 -0000

ros-noetic-exotica-ddp-solver (6.1.0-1buster) buster; urgency=high

  * Clang support and bug fixes (#731 <https://github.com/ipab-slmc/exotica/issues/731>)
  * Upgrade clang format from v3.9 to v6.0 (#730 <https://github.com/ipab-slmc/exotica/issues/730>)
  * Contributors: Wolfgang Merkt

 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Mon, 15 Mar 2021 00:00:00 -0000

ros-noetic-exotica-ddp-solver (6.0.2-1buster) buster; urgency=high



 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Mon, 23 Nov 2020 00:00:00 -0000

ros-noetic-exotica-ddp-solver (6.0.1-1buster) buster; urgency=high



 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Tue, 17 Nov 2020 00:00:00 -0000

ros-noetic-exotica-ddp-solver (6.0.0-1buster) buster; urgency=high

  * FDDP: More verbosity on NaN
  * Use state transition function + derivative in place of hard-coded scheme
  * BoxFDDP: Set default BoxQP options
  * (Box)FDDP: Add GradientTolerance convergence criterion
  * Add steplength and regularization evolution
  * CMakeLists: Upgrade minimum version to 3.0.2 to avoid CMP0048
  * FDDP: Only allocate if T changed
  * FDDP: Use const-ref for warm-start
  * Expose all internal data via const-ref getter
  * Switch FDDP to LDLT decomposition
  * Only contract with 2nd order derivatives if DynamicsSolver has them
  * Pre-allocate, go over equations, convert to trajectory pre-allocation
  * ControlLimitedDDPSolver: Clean-up Qxx, Qxu, Quu computation
  * Move costs from Solver to Problem
  * ControlLimitedDDPSolver: Add parameter for switching different BoxQP solvers
  * Introduce thresholds for increase/decrease of regularization
  * ControlLimitedDDPSolver: Add state regularization
  * Re-use already allocated variables. Fixes #678 <https://github.com/ipab-slmc/exotica/issues/678>
  * Control-limited DDP: Use fixed, low regularization for BoxQP
  * FDDP: Remove exception in ForwardPass
  * FDDP: Replace exception to adapt regularisation
  * FDDP: Use copy instead of reference to reset shooting nodes
  * BoxDDP: Clamp in forward-pass
  * Refactor FDDP to Abstract + Implementation
  * Fix NX => NDX bugs
  * Add BoxFDDP
  * Correctly resize matrices, speed up AnalyticDDPSolver::BackwardPass by using LLT
  * Use DynamicsSolver::ComputeDerivatives
  * Add FeasibilityDrivenDDPSolver
  * Contributors: Traiko Dinev, Wolfgang Merkt

 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Sun, 08 Nov 2020 00:00:00 -0000

ros-noetic-exotica-ddp-solver (5.1.3-1buster) buster; urgency=high



 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Thu, 13 Feb 2020 00:00:00 -0000

ros-noetic-exotica-ddp-solver (5.1.2-1buster) buster; urgency=high



 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Mon, 10 Feb 2020 00:00:00 -0000

ros-noetic-exotica-ddp-solver (5.1.1-1buster) buster; urgency=high



 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Mon, 10 Feb 2020 00:00:00 -0000

ros-noetic-exotica-ddp-solver (5.1.0-1buster) buster; urgency=high

  * Add exotica_ddp_solver
  * Contributors: Traiko Dinev, Wolfgang Merkt

 -- Traiko Dinev <traiko.dinev@ed.ac.uk>  Fri, 31 Jan 2020 00:00:00 -0000

=== debian/control ===
Source: ros-noetic-exotica-ddp-solver
Section: misc
Priority: optional
Maintainer: Traiko Dinev <traiko.dinev@ed.ac.uk>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-exotica-core, ros-noetic-exotica-python
Homepage: https://github.com/ipab-slmc/exotica
Standards-Version: 3.9.2

Package: ros-noetic-exotica-ddp-solver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-exotica-core, ros-noetic-exotica-python
Description: Various DDP Solvers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-exotica-ddp-solver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
